/*
 * GMS REST API
 * Date: 2019-06-28 10:13:53 | Number of web services: 176
 *
 * OpenAPI spec version: 3.1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;
import io.swagger.client.model.ErrorDto;
import io.swagger.client.model.KpiDto;
import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.CustomerDto;
import io.swagger.client.model.CustomersLastEventsCountersDto;
import io.swagger.client.model.ErrorDto;
import io.swagger.client.model.LnsCustomersLastEventsCountersDto;
import io.swagger.client.model.PaginatedDto;
import io.swagger.client.model.RncCustomerLastEventsCountersDto;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class CustomersApi {
    private ApiClient apiClient;

    public CustomersApi() {
        this(Configuration.getDefaultApiClient());
    }

    public CustomersApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for createCustomer
     * @param body The DTO JSON representation to put in the request body (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createCustomerCall(CustomerDto body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/gms/application/customers";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createCustomerValidateBeforeCall(CustomerDto body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling createCustomer(Async)");
        }
        
        com.squareup.okhttp.Call call = createCustomerCall(body, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * createCustomer
     * This web service allows to create a new customer.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;Only a SUPER_ADMIN user can write the field geolocalisationEnabled.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? SUPER_ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public String createCustomer(CustomerDto body) throws ApiException {
        ApiResponse<String> resp = createCustomerWithHttpInfo(body);
        return resp.getData();
    }

    /**
     * createCustomer
     * This web service allows to create a new customer.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;Only a SUPER_ADMIN user can write the field geolocalisationEnabled.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? SUPER_ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<String> createCustomerWithHttpInfo(CustomerDto body) throws ApiException {
        com.squareup.okhttp.Call call = createCustomerValidateBeforeCall(body, null, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * createCustomer (asynchronously)
     * This web service allows to create a new customer.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;Only a SUPER_ADMIN user can write the field geolocalisationEnabled.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? SUPER_ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createCustomerAsync(CustomerDto body, final ApiCallback<String> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createCustomerValidateBeforeCall(body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for deleteCustomer
     * @param id Customer identifier (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call deleteCustomerCall(Long id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/customers/{id}"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call deleteCustomerValidateBeforeCall(Long id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling deleteCustomer(Async)");
        }
        
        com.squareup.okhttp.Call call = deleteCustomerCall(id, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * deleteCustomer
     * This web service allows to delete a customer.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? SUPER_ADMIN&lt;br&gt;&lt;br&gt;
     * @param id Customer identifier (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void deleteCustomer(Long id) throws ApiException {
        deleteCustomerWithHttpInfo(id);
    }

    /**
     * deleteCustomer
     * This web service allows to delete a customer.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? SUPER_ADMIN&lt;br&gt;&lt;br&gt;
     * @param id Customer identifier (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> deleteCustomerWithHttpInfo(Long id) throws ApiException {
        com.squareup.okhttp.Call call = deleteCustomerValidateBeforeCall(id, null, null);
        return apiClient.execute(call);
    }

    /**
     * deleteCustomer (asynchronously)
     * This web service allows to delete a customer.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? SUPER_ADMIN&lt;br&gt;&lt;br&gt;
     * @param id Customer identifier (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deleteCustomerAsync(Long id, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deleteCustomerValidateBeforeCall(id, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for getCustomer
     * @param id Customer identifier (required)
     * @param fields List of fields to display (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getCustomerCall(Long id, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/customers/{id}"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getCustomerValidateBeforeCall(Long id, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling getCustomer(Async)");
        }
        
        com.squareup.okhttp.Call call = getCustomerCall(id, fields, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getCustomer
     * This web service allows to get a customer.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Customer identifier (required)
     * @param fields List of fields to display (optional)
     * @return CustomerDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public CustomerDto getCustomer(Long id, String fields) throws ApiException {
        ApiResponse<CustomerDto> resp = getCustomerWithHttpInfo(id, fields);
        return resp.getData();
    }

    /**
     * getCustomer
     * This web service allows to get a customer.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Customer identifier (required)
     * @param fields List of fields to display (optional)
     * @return ApiResponse&lt;CustomerDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<CustomerDto> getCustomerWithHttpInfo(Long id, String fields) throws ApiException {
        com.squareup.okhttp.Call call = getCustomerValidateBeforeCall(id, fields, null, null);
        Type localVarReturnType = new TypeToken<CustomerDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getCustomer (asynchronously)
     * This web service allows to get a customer.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Customer identifier (required)
     * @param fields List of fields to display (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getCustomerAsync(Long id, String fields, final ApiCallback<CustomerDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getCustomerValidateBeforeCall(id, fields, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<CustomerDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getCustomerMdr
     * @param day The day for which you want the data. Format : YYYYMMDD (required)
     * @param id Customer identifier (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getCustomerMdrCall(String day, Long id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/customers/{id}/mdr"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (day != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("day", day));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json", "text/csv"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getCustomerMdrValidateBeforeCall(String day, Long id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'day' is set
        if (day == null) {
            throw new ApiException("Missing the required parameter 'day' when calling getCustomerMdr(Async)");
        }
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling getCustomerMdr(Async)");
        }
        
        com.squareup.okhttp.Call call = getCustomerMdrCall(day, id, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getCustomerMdr
     * This web service allows to retrieve the MDR (Message Detail Recording) of one customer.&lt;br&gt;&lt;br&gt;Example of exchange : &lt;br&gt;&lt;br&gt;Request :&lt;br&gt;curl -v --header \&quot;Accept: application/vnd.kerlink.iot-v1+json,text/csv\&quot; --header \&quot;Authorization: Bearer &lt;br&gt;eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJzdWIiOiIxIiwiaXNzIjoib3NzQ2xpZW50IiwiZ3Jv&lt;br&gt;dXBJZCI6MSwicm9sZSI6IlNVUEVSX0FETUlOIiwiZXhwIjoxNTIyNTMzNjAwfQ.u_sln5nI-&lt;br&gt;wN6enzN_9Xi6IMK65ofLvBsWjyoJyHldLA\&quot; \&quot;http://localhost:80/gms/application/customers/1/mdr?day&#x3D;20180211\&quot; | gunzip &gt; MDR_120180211.csv&lt;br&gt;&lt;br&gt;Response (CSV) :&lt;br&gt;Timestamp,DevEUI,Direction,DataRate,FramePayloadSize,PhysicalPayloadSize,ClusterId,CustomerId&lt;br&gt;1536451302143,1337133713371337,UPLINK,SF7BW125,16,29,207,1&lt;br&gt;1536451602142,1337133713371337,UPLINK,SF7BW125,16,29,207,1&lt;br&gt;1536451902142,1337133713371337,UPLINK,SF7BW125,16,29,207,1&lt;br&gt;1536452202142,1337133713371337,UPLINK,SF7BW125,16,29,207,1&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.3.0&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param day The day for which you want the data. Format : YYYYMMDD (required)
     * @param id Customer identifier (required)
     * @return ErrorDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ErrorDto getCustomerMdr(String day, Long id) throws ApiException {
        ApiResponse<ErrorDto> resp = getCustomerMdrWithHttpInfo(day, id);
        return resp.getData();
    }

    /**
     * getCustomerMdr
     * This web service allows to retrieve the MDR (Message Detail Recording) of one customer.&lt;br&gt;&lt;br&gt;Example of exchange : &lt;br&gt;&lt;br&gt;Request :&lt;br&gt;curl -v --header \&quot;Accept: application/vnd.kerlink.iot-v1+json,text/csv\&quot; --header \&quot;Authorization: Bearer &lt;br&gt;eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJzdWIiOiIxIiwiaXNzIjoib3NzQ2xpZW50IiwiZ3Jv&lt;br&gt;dXBJZCI6MSwicm9sZSI6IlNVUEVSX0FETUlOIiwiZXhwIjoxNTIyNTMzNjAwfQ.u_sln5nI-&lt;br&gt;wN6enzN_9Xi6IMK65ofLvBsWjyoJyHldLA\&quot; \&quot;http://localhost:80/gms/application/customers/1/mdr?day&#x3D;20180211\&quot; | gunzip &gt; MDR_120180211.csv&lt;br&gt;&lt;br&gt;Response (CSV) :&lt;br&gt;Timestamp,DevEUI,Direction,DataRate,FramePayloadSize,PhysicalPayloadSize,ClusterId,CustomerId&lt;br&gt;1536451302143,1337133713371337,UPLINK,SF7BW125,16,29,207,1&lt;br&gt;1536451602142,1337133713371337,UPLINK,SF7BW125,16,29,207,1&lt;br&gt;1536451902142,1337133713371337,UPLINK,SF7BW125,16,29,207,1&lt;br&gt;1536452202142,1337133713371337,UPLINK,SF7BW125,16,29,207,1&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.3.0&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param day The day for which you want the data. Format : YYYYMMDD (required)
     * @param id Customer identifier (required)
     * @return ApiResponse&lt;ErrorDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ErrorDto> getCustomerMdrWithHttpInfo(String day, Long id) throws ApiException {
        com.squareup.okhttp.Call call = getCustomerMdrValidateBeforeCall(day, id, null, null);
        Type localVarReturnType = new TypeToken<ErrorDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getCustomerMdr (asynchronously)
     * This web service allows to retrieve the MDR (Message Detail Recording) of one customer.&lt;br&gt;&lt;br&gt;Example of exchange : &lt;br&gt;&lt;br&gt;Request :&lt;br&gt;curl -v --header \&quot;Accept: application/vnd.kerlink.iot-v1+json,text/csv\&quot; --header \&quot;Authorization: Bearer &lt;br&gt;eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJzdWIiOiIxIiwiaXNzIjoib3NzQ2xpZW50IiwiZ3Jv&lt;br&gt;dXBJZCI6MSwicm9sZSI6IlNVUEVSX0FETUlOIiwiZXhwIjoxNTIyNTMzNjAwfQ.u_sln5nI-&lt;br&gt;wN6enzN_9Xi6IMK65ofLvBsWjyoJyHldLA\&quot; \&quot;http://localhost:80/gms/application/customers/1/mdr?day&#x3D;20180211\&quot; | gunzip &gt; MDR_120180211.csv&lt;br&gt;&lt;br&gt;Response (CSV) :&lt;br&gt;Timestamp,DevEUI,Direction,DataRate,FramePayloadSize,PhysicalPayloadSize,ClusterId,CustomerId&lt;br&gt;1536451302143,1337133713371337,UPLINK,SF7BW125,16,29,207,1&lt;br&gt;1536451602142,1337133713371337,UPLINK,SF7BW125,16,29,207,1&lt;br&gt;1536451902142,1337133713371337,UPLINK,SF7BW125,16,29,207,1&lt;br&gt;1536452202142,1337133713371337,UPLINK,SF7BW125,16,29,207,1&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.3.0&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param day The day for which you want the data. Format : YYYYMMDD (required)
     * @param id Customer identifier (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getCustomerMdrAsync(String day, Long id, final ApiCallback<ErrorDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getCustomerMdrValidateBeforeCall(day, id, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ErrorDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getCustomers
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getCustomersCall(String fields, String page, String pageSize, String search, String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/customers";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("pageSize", pageSize));
        if (search != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("search", search));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getCustomersValidateBeforeCall(String fields, String page, String pageSize, String search, String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = getCustomersCall(fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getCustomers
     * This web service allows to get the list of customers.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? SUPER_ADMIN&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<CustomerDto> getCustomers(String fields, String page, String pageSize, String search, String sort) throws ApiException {
        ApiResponse<PaginatedDto<CustomerDto>> resp = getCustomersWithHttpInfo(fields, page, pageSize, search, sort);
        return resp.getData();
    }

    /**
     * getCustomers
     * This web service allows to get the list of customers.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? SUPER_ADMIN&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<CustomerDto>> getCustomersWithHttpInfo(String fields, String page, String pageSize, String search, String sort) throws ApiException {
        com.squareup.okhttp.Call call = getCustomersValidateBeforeCall(fields, page, pageSize, search, sort, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<CustomerDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getCustomers (asynchronously)
     * This web service allows to get the list of customers.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? SUPER_ADMIN&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getCustomersAsync(String fields, String page, String pageSize, String search, String sort, final ApiCallback<PaginatedDto<CustomerDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getCustomersValidateBeforeCall(fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<CustomerDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getCustomersLastEventsCounters
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getCustomersLastEventsCountersCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/customers/events/last/counters";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getCustomersLastEventsCountersValidateBeforeCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = getCustomersLastEventsCountersCall(progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getCustomersLastEventsCounters
     * This web service allows to retrieve all the unread last events counters attached to all the customers.&lt;br&gt;The result contains the main alarm and notification counters. It is also aggregated by customer and fleet.&lt;br&gt;All the fleets are retrieved for each customer.&lt;br&gt;The customers without any counters (or counters equal 0) are not retrieved.&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @return CustomersLastEventsCountersDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public CustomersLastEventsCountersDto getCustomersLastEventsCounters() throws ApiException {
        ApiResponse<CustomersLastEventsCountersDto> resp = getCustomersLastEventsCountersWithHttpInfo();
        return resp.getData();
    }

    /**
     * getCustomersLastEventsCounters
     * This web service allows to retrieve all the unread last events counters attached to all the customers.&lt;br&gt;The result contains the main alarm and notification counters. It is also aggregated by customer and fleet.&lt;br&gt;All the fleets are retrieved for each customer.&lt;br&gt;The customers without any counters (or counters equal 0) are not retrieved.&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @return ApiResponse&lt;CustomersLastEventsCountersDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<CustomersLastEventsCountersDto> getCustomersLastEventsCountersWithHttpInfo() throws ApiException {
        com.squareup.okhttp.Call call = getCustomersLastEventsCountersValidateBeforeCall(null, null);
        Type localVarReturnType = new TypeToken<CustomersLastEventsCountersDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getCustomersLastEventsCounters (asynchronously)
     * This web service allows to retrieve all the unread last events counters attached to all the customers.&lt;br&gt;The result contains the main alarm and notification counters. It is also aggregated by customer and fleet.&lt;br&gt;All the fleets are retrieved for each customer.&lt;br&gt;The customers without any counters (or counters equal 0) are not retrieved.&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getCustomersLastEventsCountersAsync(final ApiCallback<CustomersLastEventsCountersDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getCustomersLastEventsCountersValidateBeforeCall(progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<CustomersLastEventsCountersDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getLnsCustomersLastEventsCounters
     * @param fields List of fields to display (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getLnsCustomersLastEventsCountersCall(String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/customers/lnsEvents/last/counters";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getLnsCustomersLastEventsCountersValidateBeforeCall(String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = getLnsCustomersLastEventsCountersCall(fields, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getLnsCustomersLastEventsCounters
     * This web service allows to retrieve all the LNS last events counters.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;li&gt;If the connected user has the role SUPER_ADMIN, all the counters are returned otherwise only the counters attached to his customer.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @return LnsCustomersLastEventsCountersDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public LnsCustomersLastEventsCountersDto getLnsCustomersLastEventsCounters(String fields) throws ApiException {
        ApiResponse<LnsCustomersLastEventsCountersDto> resp = getLnsCustomersLastEventsCountersWithHttpInfo(fields);
        return resp.getData();
    }

    /**
     * getLnsCustomersLastEventsCounters
     * This web service allows to retrieve all the LNS last events counters.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;li&gt;If the connected user has the role SUPER_ADMIN, all the counters are returned otherwise only the counters attached to his customer.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @return ApiResponse&lt;LnsCustomersLastEventsCountersDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<LnsCustomersLastEventsCountersDto> getLnsCustomersLastEventsCountersWithHttpInfo(String fields) throws ApiException {
        com.squareup.okhttp.Call call = getLnsCustomersLastEventsCountersValidateBeforeCall(fields, null, null);
        Type localVarReturnType = new TypeToken<LnsCustomersLastEventsCountersDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getLnsCustomersLastEventsCounters (asynchronously)
     * This web service allows to retrieve all the LNS last events counters.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;li&gt;If the connected user has the role SUPER_ADMIN, all the counters are returned otherwise only the counters attached to his customer.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getLnsCustomersLastEventsCountersAsync(String fields, final ApiCallback<LnsCustomersLastEventsCountersDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getLnsCustomersLastEventsCountersValidateBeforeCall(fields, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<LnsCustomersLastEventsCountersDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getRncCustomerKpi
     * @param id Kpi identifier from predefined set {DOWNLINK_BYTES, NB_DOWNLINK, NB_END_DEVICE, NB_UPLINK, PING, RSSI_UPLINK_MESSAGE, SNR_UPLINK_MESSAGE, TOA_DOWNLINK_MESSAGE, TOA_UPLINK_MESSAGE, UPLINK_BYTES} (required)
     * @param kpi Identifier (required)
     * @param period Aggregation period from predefined set {DAY, HOUR, MINUTE, MONTH, WEEK, YEAR} (required)
     * @param activationType For kpi&#x3D;NB_END_DEVICE only KPI : {ABP, OTAA} (optional)
     * @param frq For kpi&#x3D;TOA_DOWNLINK_MESSAGE only (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param sf For kpi&#x3D;TOA_DOWNLINK_MESSAGE only (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getRncCustomerKpiCall(Long id, String kpi, String period, String activationType, String frq, String page, String pageSize, String sf, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/customers/{id}/kpis/{kpi}"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()))
            .replaceAll("\\{" + "kpi" + "\\}", apiClient.escapeString(kpi.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (activationType != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("activationType", activationType));
        if (frq != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("frq", frq));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("pageSize", pageSize));
        if (period != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("period", period));
        if (sf != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sf", sf));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getRncCustomerKpiValidateBeforeCall(Long id, String kpi, String period, String activationType, String frq, String page, String pageSize, String sf, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling getRncCustomerKpi(Async)");
        }
        // verify the required parameter 'kpi' is set
        if (kpi == null) {
            throw new ApiException("Missing the required parameter 'kpi' when calling getRncCustomerKpi(Async)");
        }
        // verify the required parameter 'period' is set
        if (period == null) {
            throw new ApiException("Missing the required parameter 'period' when calling getRncCustomerKpi(Async)");
        }
        
        com.squareup.okhttp.Call call = getRncCustomerKpiCall(id, kpi, period, activationType, frq, page, pageSize, sf, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getRncCustomerKpi
     * This web service returns a KPI by customer for one customer.&lt;br&gt;&lt;br&gt;Since: v3.0.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Kpi identifier from predefined set {DOWNLINK_BYTES, NB_DOWNLINK, NB_END_DEVICE, NB_UPLINK, PING, RSSI_UPLINK_MESSAGE, SNR_UPLINK_MESSAGE, TOA_DOWNLINK_MESSAGE, TOA_UPLINK_MESSAGE, UPLINK_BYTES} (required)
     * @param kpi Identifier (required)
     * @param period Aggregation period from predefined set {DAY, HOUR, MINUTE, MONTH, WEEK, YEAR} (required)
     * @param activationType For kpi&#x3D;NB_END_DEVICE only KPI : {ABP, OTAA} (optional)
     * @param frq For kpi&#x3D;TOA_DOWNLINK_MESSAGE only (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param sf For kpi&#x3D;TOA_DOWNLINK_MESSAGE only (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<KpiDto> getRncCustomerKpi(Long id, String kpi, String period, String activationType, String frq, String page, String pageSize, String sf) throws ApiException {
        ApiResponse<PaginatedDto<KpiDto>> resp = getRncCustomerKpiWithHttpInfo(id, kpi, period, activationType, frq, page, pageSize, sf);
        return resp.getData();
    }

    /**
     * getRncCustomerKpi
     * This web service returns a KPI by customer for one customer.&lt;br&gt;&lt;br&gt;Since: v3.0.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Kpi identifier from predefined set {DOWNLINK_BYTES, NB_DOWNLINK, NB_END_DEVICE, NB_UPLINK, PING, RSSI_UPLINK_MESSAGE, SNR_UPLINK_MESSAGE, TOA_DOWNLINK_MESSAGE, TOA_UPLINK_MESSAGE, UPLINK_BYTES} (required)
     * @param kpi Identifier (required)
     * @param period Aggregation period from predefined set {DAY, HOUR, MINUTE, MONTH, WEEK, YEAR} (required)
     * @param activationType For kpi&#x3D;NB_END_DEVICE only KPI : {ABP, OTAA} (optional)
     * @param frq For kpi&#x3D;TOA_DOWNLINK_MESSAGE only (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param sf For kpi&#x3D;TOA_DOWNLINK_MESSAGE only (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<KpiDto>> getRncCustomerKpiWithHttpInfo(Long id, String kpi, String period, String activationType, String frq, String page, String pageSize, String sf) throws ApiException {
        com.squareup.okhttp.Call call = getRncCustomerKpiValidateBeforeCall(id, kpi, period, activationType, frq, page, pageSize, sf, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<KpiDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getRncCustomerKpi (asynchronously)
     * This web service returns a KPI by customer for one customer.&lt;br&gt;&lt;br&gt;Since: v3.0.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Kpi identifier from predefined set {DOWNLINK_BYTES, NB_DOWNLINK, NB_END_DEVICE, NB_UPLINK, PING, RSSI_UPLINK_MESSAGE, SNR_UPLINK_MESSAGE, TOA_DOWNLINK_MESSAGE, TOA_UPLINK_MESSAGE, UPLINK_BYTES} (required)
     * @param kpi Identifier (required)
     * @param period Aggregation period from predefined set {DAY, HOUR, MINUTE, MONTH, WEEK, YEAR} (required)
     * @param activationType For kpi&#x3D;NB_END_DEVICE only KPI : {ABP, OTAA} (optional)
     * @param frq For kpi&#x3D;TOA_DOWNLINK_MESSAGE only (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param sf For kpi&#x3D;TOA_DOWNLINK_MESSAGE only (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getRncCustomerKpiAsync(Long id, String kpi, String period, String activationType, String frq, String page, String pageSize, String sf, final ApiCallback<PaginatedDto<KpiDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getRncCustomerKpiValidateBeforeCall(id, kpi, period, activationType, frq, page, pageSize, sf, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<KpiDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getRncCustomersLastEventsCounters
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getRncCustomersLastEventsCountersCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/customers/rncEvents/last/counters";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getRncCustomersLastEventsCountersValidateBeforeCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = getRncCustomersLastEventsCountersCall(progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getRncCustomersLastEventsCounters
     * This web service returns the counters of the unread RNC last events of all the customers.&lt;br&gt;&lt;br&gt;Since: v2.3.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @return RncCustomerLastEventsCountersDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public RncCustomerLastEventsCountersDto getRncCustomersLastEventsCounters() throws ApiException {
        ApiResponse<RncCustomerLastEventsCountersDto> resp = getRncCustomersLastEventsCountersWithHttpInfo();
        return resp.getData();
    }

    /**
     * getRncCustomersLastEventsCounters
     * This web service returns the counters of the unread RNC last events of all the customers.&lt;br&gt;&lt;br&gt;Since: v2.3.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @return ApiResponse&lt;RncCustomerLastEventsCountersDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<RncCustomerLastEventsCountersDto> getRncCustomersLastEventsCountersWithHttpInfo() throws ApiException {
        com.squareup.okhttp.Call call = getRncCustomersLastEventsCountersValidateBeforeCall(null, null);
        Type localVarReturnType = new TypeToken<RncCustomerLastEventsCountersDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getRncCustomersLastEventsCounters (asynchronously)
     * This web service returns the counters of the unread RNC last events of all the customers.&lt;br&gt;&lt;br&gt;Since: v2.3.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getRncCustomersLastEventsCountersAsync(final ApiCallback<RncCustomerLastEventsCountersDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getRncCustomersLastEventsCountersValidateBeforeCall(progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<RncCustomerLastEventsCountersDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for patchCustomer
     * @param body The DTO JSON representation to put in the request body (required)
     * @param id Customer identifier (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call patchCustomerCall(CustomerDto body, Long id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/gms/application/customers/{id}"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "PATCH", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call patchCustomerValidateBeforeCall(CustomerDto body, Long id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling patchCustomer(Async)");
        }
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling patchCustomer(Async)");
        }
        
        com.squareup.okhttp.Call call = patchCustomerCall(body, id, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * patchCustomer
     * This web service allows to patch a customer.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;li&gt;Only a SUPER_ADMIN user can manage the fields {maxEndDevices, maxGateways, maxUsers}&lt;/li&gt;&lt;li&gt;The maxGateways value cannot be less than the actual number of gateways.&lt;/li&gt;&lt;li&gt;The maxEndDevices value cannot be less than the actual number of end-devices.&lt;/li&gt;&lt;li&gt;The maxUsers value cannot be less than the actual number of users.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param id Customer identifier (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void patchCustomer(CustomerDto body, Long id) throws ApiException {
        patchCustomerWithHttpInfo(body, id);
    }

    /**
     * patchCustomer
     * This web service allows to patch a customer.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;li&gt;Only a SUPER_ADMIN user can manage the fields {maxEndDevices, maxGateways, maxUsers}&lt;/li&gt;&lt;li&gt;The maxGateways value cannot be less than the actual number of gateways.&lt;/li&gt;&lt;li&gt;The maxEndDevices value cannot be less than the actual number of end-devices.&lt;/li&gt;&lt;li&gt;The maxUsers value cannot be less than the actual number of users.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param id Customer identifier (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> patchCustomerWithHttpInfo(CustomerDto body, Long id) throws ApiException {
        com.squareup.okhttp.Call call = patchCustomerValidateBeforeCall(body, id, null, null);
        return apiClient.execute(call);
    }

    /**
     * patchCustomer (asynchronously)
     * This web service allows to patch a customer.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;li&gt;Only a SUPER_ADMIN user can manage the fields {maxEndDevices, maxGateways, maxUsers}&lt;/li&gt;&lt;li&gt;The maxGateways value cannot be less than the actual number of gateways.&lt;/li&gt;&lt;li&gt;The maxEndDevices value cannot be less than the actual number of end-devices.&lt;/li&gt;&lt;li&gt;The maxUsers value cannot be less than the actual number of users.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param id Customer identifier (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call patchCustomerAsync(CustomerDto body, Long id, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = patchCustomerValidateBeforeCall(body, id, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
}
